void main(void){

    INTEnableSystemMultiVectoredInt();
    ANSELA = 0; ANSELB = 0;                 // Disable analog inputs
    CM1CON = 0; CM2CON = 0; CM3CON = 0;     // Disable analog comparators
    
    setupUART();
    homePutty();
    clearPutty();
    setupSPI();


//*************************** MAIN *******************************//

unsigned char option, error, data, FAT32_active = 1;
unsigned int i;
unsigned char fileName[13];

printf ("*********************************************\n");
printf ("*********************************************\n");
printf ("     Meng project microSD Card Testing..     \n");
printf ("*********************************************\n");
printf ("*********************************************\n");
printf("\n");

cardType = 0;

for (i=0; i<10; i++)
{
  error = SD_init();
  if(!error) break;
}

if(error)
{
  if(error == 1) printf("SD card not detected..");
  if(error == 2) printf("Card Initialization failed..");

  while(1);  //wait here forever if error in SD init 
}


    SpiChnClose(1);
   // SpiChnOpen(1, SPI_OPEN_ON | SPI_OPEN_MODE8 | SPI_OPEN_MSTEN , 4 | SPI_OPEN_SMP_END);// change the SPI CLK speed 
    
    
    SpiChnOpen(1, SPI_OPEN_ON | SPI_OPEN_MODE8 | SPI_OPEN_MSTEN , 4 | SPI_OPEN_SMP_END);// change the SPI CLK speed 

switch (cardType)
{
  case 1:printf("Standard Capacity Card (Ver 1.x) Detected!");
  		 break;
  case 2:printf("High Capacity Card Detected!");
  		 break;
  case 3:printf("Standard Capacity Card (Ver 2.x) Detected!");
  		 break;
  default:printf("Unknown SD Card Detected!");
  		 break; 
}

printf("\n");

error = getBootSectorData(); //read boot sector and keep necessary data in global variables
printf("getBootSectorData_error = %d",error);
if(error) 	
{
  printf("\n");
  printf("FAT32 not found!");  //FAT32 incompatible drive
  FAT32_active = 0;
}

while(1)
{
printf("\n");
printf("Press any key to start...");
printf("\n");
option = receiveByte();
printf("\n");
printf("> 0 : Erase Blocks");
printf("\n");
printf("> 1 : Write single Block");
printf("\n");
printf("> 2 : Read single Block");




#ifndef FAT_TESTING_ONLY
printf("\n");
printf("> 3 : Write multiple Blocks");
printf("\n");
printf("> 4 : Read multiple Blocks");
#endif


printf("\n");
printf("> 5 : Get file list");
printf("\n");
printf("> 6 : Read File");
printf("\n");
printf("> 7 : Write File");
printf("\n");
printf("> 8 : Delete File");
printf("\n");
printf("> 9 : Read SD Memory Capacity (Total/Free)");

printf("\n");
printf("\n");
printf("> Select Option (0-9): ");


/*WARNING: If option 0, 1 or 3 is selected, the card may not be detected by PC/Laptop again,
as it disturbs the FAT format, and you may have to format it again with FAT32.
This options are given for learnig the raw data transfer to & from the SD Card*/

option = receiveByte();
transmitByte(option);

if(option >=0x35 && option <=0x39)  //options 5 to 9 disabled if FAT32 not found
{
  if(!FAT32_active) 
  {
    printf("\n");
    printf("\n");
	printf("FAT32 options disabled!");
	continue;
  } 
}


if((option >= 0x30) && (option <=0x34)) //get starting block address for options 0 to 4
{
printf("\n");
printf("\n");
printf("Enter the Block number (0000-9999):");
data = receiveByte(); transmitByte(data);
startBlock = (data & 0x0f) * 1000;
data = receiveByte(); transmitByte(data);
startBlock += (data & 0x0f) * 100;
data = receiveByte(); transmitByte(data);
startBlock += (data & 0x0f) * 10;
data = receiveByte(); transmitByte(data);
startBlock += (data & 0x0f);
printf("\n");
printf("start_block_addr = %d" , startBlock);
printf("\n");

}

totalBlocks = 1;

#ifndef FAT_TESTING_ONLY

if((option == 0x30) || (option == 0x33) || (option == 0x34)) //get total number of blocks for options 0, 3 or 4
{
printf("\n");
printf("\n");
printf("How many blocks? (000-999):");
data = receiveByte(); transmitByte(data);
totalBlocks = (data & 0x0f) * 100;
data = receiveByte(); transmitByte(data);
totalBlocks += (data & 0x0f) * 10;
data = receiveByte(); transmitByte(data);
totalBlocks += (data & 0x0f);
printf("\n");
}
#endif

switch (option)
{
case '0': //error = SD_erase (block, totalBlocks);
    
   
          error = SD_erase (startBlock, totalBlocks);
         printf("\n");
          if(error)
              printf("Erase failed..");
          else
              printf("Erased!");
          break;

case '1': 
          printf("\n");;
          printf(" Enter text (End with ~):");
          i=0;
            do
            {
                data = receiveByte();
                transmitByte(data);
                buffer[i++] = data;
                if(data == 0x0d)
                {
                    transmitByte(0x0a);
                    buffer[i++] = 0x0a;
                }
                if(i == 512) break;
            }while (data != '~');

            error = SD_writeSingleBlock (startBlock);
            printf("\n");
            printf("\n");
            if(error)
                printf("Write failed..");
            else
                printf("Write successful!");
            break;

case '2': error = SD_readSingleBlock (startBlock);   //SD_readSingleBlock (74100588);
          printf("\n");
          if(error)
            printf("Read failed..");
          else
          {
            for(i=0;i<512;i++)
            {
                if(buffer[i] == '~') break;
                transmitByte(buffer[i]);
            }
            printf("\n");
            printf("\n");
            printf("Read successful!");
          }

          break;
//next two options will work only if following macro is cleared from SD_routines.h
#ifndef FAT_TESTING_ONLY

case '3': 
          error = SD_writeMultipleBlock (startBlock, totalBlocks);
          printf("\n");
          if(error)
            printf("Write failed..");
          else
            printf("Write successful!");
          break;

case '4': error = SD_readMultipleBlock (startBlock, totalBlocks);
          printf("\n");
          if(error)
            printf("Read failed..");
          else
            printf("Read successful!");
          break;
#endif

case '5': printf("\n");
          printf("\n");
          
  		  findFiles(GET_LIST,0);


              
          break;
          

case '6':
case '7': 
case '8': printf("\n");
		  printf("\n");
          printf("Enter file name: ");
          for(i=0; i<13; i++)
			fileName[i] = 0x00;   //clearing any previously stored file name
          i=0;
          while(1)
          {
            data = receiveByte();
            if(data == 0x0d) break;  //'ENTER' key pressed
			if(data == 0x08)	//'Back Space' key pressed
	 		{ 
	   			if(i != 0)
	   			{ 
	     			transmitByte(data);
					transmitByte(' '); 
	     			transmitByte(data); 
	     			i--; 
	   			} 
	   			continue;     
	 		}
			if(data <0x20 || data > 0x7e) continue;  //check for valid English text character
			transmitByte(data);
            fileName[i++] = data;
            if(i==13){printf(" file name too long.."); break;}
          }
          if(i>12) break;
       
	      printf("\n");
		  if(option == '6')
		     readFile( READ, fileName);
		  if(option == '7')
		  	 writeFile(fileName);
 		  if(option == '8')
		     deleteFile(fileName);
          break;

case '9': memoryStatistics();
data = receiveByte();
          break;

default: printf("\n");
         printf("\n");
         printf(" Invalid option!");
         printf("\n");
}

printf("\n");
}
return 0;
}


